; Formal verification proof - SCLBool with Bool Specification of test_netlist_c17.txt
(set-logic QF_BV)

; Inputs: ni1_1, ni2_1, ni3_1, ni6_1, ni7_1, ni1_0, ni2_0, ni3_0, ni6_0, ni7_0
(declare-fun ni1_1 () (_ BitVec 1))
(declare-fun ni2_1 () (_ BitVec 1))
(declare-fun ni3_1 () (_ BitVec 1))
(declare-fun ni6_1 () (_ BitVec 1))
(declare-fun ni7_1 () (_ BitVec 1))

; Outputs: n22_1, n23_1, n22_0, n23_0

(declare-fun n22_0 () (_ BitVec 1))
(declare-fun n23_0 () (_ BitVec 1))

(declare-fun n22_1 () (_ BitVec 1))
(declare-fun n23_1 () (_ BitVec 1))


;----------------------- th22 Function---------------------------------
(define-fun th22 ((a (_ BitVec 1)) (b (_ BitVec 1))) (_ BitVec 1)
	(bvand a b) )

	
;----------------------- thand0 Function---------------------------------
(define-fun thand0 ((a (_ BitVec 1)) (b (_ BitVec 1))(c (_ BitVec 1)) (d (_ BitVec 1)) ) (_ BitVec 1)
	(bvor (bvand a b) (bvor (bvand b c) (bvand a d) ) ) ) 

	

; SAT/UNSAT assertion for test_netlist_c17.txt
(assert
	(not		
		(let
			(
				(ni1_0 (bvnot ni1_1 ))
				(ni2_0 (bvnot ni2_1 ))
				(ni3_0 (bvnot ni3_1 ))
				(ni6_0 (bvnot ni6_1 ))
				(ni7_0 (bvnot ni7_1 ))
				(n10_0 (th22 ni1_1  ni3_1 ))
				(n11_0 (th22 ni6_1  ni3_1 ))
			)		
		(let
			(
				(n10_1 (thand0 ni1_0  ni3_0  ni1_1  ni3_1 ))
				(n11_1 (thand0 ni6_0  ni3_0  ni6_1  ni3_1 ))
			)		
		(let
			(
				(n16_0 (th22 n11_1  ni2_1 ))
				(n19_0 (th22 n11_1  ni7_1 ))
				(n16_1 (thand0 n11_0  ni2_0  n11_1  ni2_1 ))
				(n19_1 (thand0 n11_0  ni7_0  n11_1  ni7_1 ))
			)		
		(let
			(
				(n22_0 (th22 n10_1  n16_1 ))
				(n23_0 (th22 n19_1  n16_1 ))
				(n22_1 (thand0 n10_0  n16_0  n10_1  n16_1 ))
				(n23_1 (thand0 n19_0  n16_0  n19_1  n16_1 ))
			)		
		
		
;        ------------------Sync Specification -------------------
		(let 
			(
				(sync_n22 (bvnand (bvnand ni1_1 ni3_1) (bvnand (bvnand ni3_1 ni6_1) ni2_1)))
				(sync_n23 (bvnand (bvnand (bvnand ni3_1 ni6_1) ni2_1) (bvnand (bvnand ni3_1 ni6_1) ni7_1) ))
			)
		
		
			(and
				(= n22_1 sync_n22) 
				(= n23_1 sync_n23)
				(not
					(= n22_0 n22_1))
				(not
					(= n23_0 n23_1))	
			)
				
				
		)  ))))
	)
)	
(check-sat)
(get-model)
