import os
import re
import networkx as nx

class SCLSync():

    inputs = []
    outputs = []
    inputs1 = []
    outputs1 = []
    num_gates = 0
    num_Bool_gates=0
    num_levels = 0
    num_comps = 0
    num_not = 0
    num_RegN = 0
    num_RegD = 0
    num_Reg = 0
    num_C = 0
    
    gate_inputs_number= 0
    gate_info = dict()
    Bool_gate_info= dict()
    comp_info= dict()
    not_info= dict()
    RegN_info= dict()
    RegD_info = dict()
    Reg_info = dict()
    C_info = dict()
    
    

    def __init__(self, netlist, outfile, outfile1):
        self.netlist = netlist
        self.outfile = outfile
        self.outfile1 = outfile1
        self._process_netlist()

    def _process_netlist(self):
        """Process the netlist file to identify inputs, outputs, and gates used"""
        with open(self.netlist, 'r') as netlist_file:
            var= netlist_file.readline().rstrip().split(',')
            for x in var:
                self.inputs.append(x)
                mat1= re.search (r'(.*_(?P<rail>[0-9]+)$)',x)
                m= mat1.group ('rail')
                if m == '1':
                    self.inputs1.append(x)
#            print (self.inputs)
            var1= netlist_file.readline().rstrip().split(',')
            for x in var1: 
                self.outputs.append(x)
                mat1= re.search (r'(.*_(?P<rail>[0-9]+)$)',x)
                m= mat1.group ('rail')
                if m == '1':
                    self.outputs1.append(x)
#            print (self.outputs)
          
            for line in netlist_file:
#               As Completion units donot have any 'level' column
                (gate, others1) = line.split(' ',1)
                if (gate!='Comp') or (gate!= 'C'):
                    (level,others) = others1.split(' ',1)
                if (gate != 'C') and (gate != 'Comp') and (gate != 'Reg_NULL') and (gate != 'Reg_DATA') :
                    
                    (gate_op, slp, gate_inputs)= others.split(' ',2)
                    self.gate_info['gate_inputs'] = gate_inputs.split(',')
                    self.num_gates += 1
                    self.gate_info[self.num_gates] = dict()
                    self.gate_info[self.num_gates]['type'] = gate
                    self.gate_info[self.num_gates]['level'] = level
                    self.gate_info[self.num_gates]['gate_inputs'] = gate_inputs.rstrip().split(',')
#                    print (self.gate_info[self.num_gates]['gate_inputs'])
                    self.gate_info[self.num_gates]['slp']= slp
                    self.gate_info[self.num_gates]['slp_list'] = slp.split(',')
#                    print (self.gate_info[self.num_gates]['slp'])
                    self.gate_info[self.num_gates]['gate_outputs'] = gate_op.rstrip().split(',')
#                    print (self.gate_info[self.num_gates]['gate_outputs'][0])
#                    print (self.gate_info[self.num_gates]['gate_inputs'])   
                if (gate == 'Reg_NULL'):
                    self.num_RegN += 1
                    self.RegN_info[self.num_RegN] = dict()
                    self.RegN_info[self.num_RegN]['type'] = gate
                    self.RegN_info[self.num_RegN]['level'] = level
                    (rail0_ip, rail1_ip, slp, rail0_op, rail1_op)= others.split(' ',4)
                    self.RegN_info[self.num_RegN]['rail0_input'] = rail0_ip.split(',')
                    self.RegN_info[self.num_RegN]['rail1_input'] = rail1_ip.split(',')
                    self.RegN_info[self.num_RegN]['rail0_output'] = rail0_op.rstrip().split(',')
                    self.RegN_info[self.num_RegN]['rail1_output'] = rail1_op.rstrip().split(',')
                    self.RegN_info[self.num_RegN]['slp'] =  slp
#                    print (self.RegN_info[self.num_RegN]['slp'])
                    
                if (gate == 'Reg_DATA'):
                    self.num_RegD += 1
                    self.RegD_info[self.num_RegD] = dict()
                    self.RegD_info[self.num_RegD]['type'] = gate
                    self.RegD_info[self.num_RegD]['level'] = level
                    (rail0_ip, rail1_ip, slp, rail0_op, rail1_op)= others.split(' ',4)
                    self.RegD_info[self.num_RegD]['rail0_init_input'] = rail0_ip.split(',')
                    self.RegD_info[self.num_RegD]['rail1_init_input'] = rail1_ip.split(',')
                    self.RegD_info[self.num_RegD]['rail0_output'] = rail0_op.rstrip().split(',')
                    self.RegD_info[self.num_RegD]['rail1_output'] = rail1_op.rstrip().split(',')
                    self.RegD_info[self.num_RegD]['slp'] =  slp
#                    print (self.RegD_info[self.num_RegD]['slp'])
                if (gate == 'C'):
                    self.num_C += 1
                    self.C_info[self.num_C] = dict()
                    self.C_info[self.num_C]['type'] = gate
#                    self.comp_info[self.num_comps]['level'] = level
                    (gate_inputs,gate_op)= others1.split(' ',1)
                    self.C_info[self.num_C]['C_inputs'] = gate_inputs.split(',')
                    self.C_info[self.num_C]['C_outputs'] = gate_op.rstrip() 
#                    print (self.C_info[self.num_C]['C_inputs'] )
                    
                if (gate == 'Comp'):
                    self.num_comps += 1
                    self.comp_info[self.num_comps] = dict()
                    self.comp_info[self.num_comps]['type'] = gate
#                    self.comp_info[self.num_comps]['level'] = level
                    (comp_next, gate_inputs, sleep, gate_op)= others1.split(' ',3)
                    self.comp_info[self.num_comps]['comp_next'] = comp_next
                    self.comp_info[self.num_comps]['comp_inputs'] = gate_inputs.split(',')
                    self.comp_info[self.num_comps]['sleep'] = sleep
                    self.comp_info[self.num_comps]['comp_outputs'] = gate_op.rstrip()
#                    print (self.comp_info[self.num_comps]['comp_inputs'])
#                    print (self.comp_info[self.num_comps]['comp_prev'])   
                self.comp_info['comp_outputs_list']=[]
                for x in range(1,self.num_comps+1):
                    self.comp_info['comp_outputs_list'].append(self.comp_info[x]['comp_outputs'])
#                del self.gate_info[1]['th12']
#                print (self.gate_info.keys())    

         
#############   Creating a list for all REGISTERS irrespective of NULL or DATA Type #### 
                if (gate == 'Reg_NULL') or (gate == 'Reg_DATA'):
                    self.num_Reg += 1
                    self.Reg_info[self.num_Reg] = dict()
                    self.Reg_info[self.num_Reg]['type'] = gate
                    self.Reg_info[self.num_Reg]['level'] = level
                    (rail0_ip, rail1_ip, slp, rail0_op, rail1_op)= others.split(' ',4)
                    self.Reg_info[self.num_Reg]['rail0_input'] = rail0_ip.split(',')
                    self.Reg_info[self.num_Reg]['rail1_input'] = rail1_ip.split(',')
                    self.Reg_info[self.num_Reg]['rail0_output'] = rail0_op.rstrip().split(',')
                    self.Reg_info[self.num_Reg]['rail1_output'] = rail1_op.rstrip().split(',')
                    self.Reg_info[self.num_Reg]['slp'] =  slp
                    self.Reg_info[self.num_Reg]['Reg_inputs']=[]
                    self.Reg_info[self.num_Reg]['Reg_inputs'].append(rail0_ip)
                    self.Reg_info[self.num_Reg]['Reg_inputs'].append(rail1_ip)
                    self.Reg_info[self.num_Reg]['Reg_outputs']=[]
                    self.Reg_info[self.num_Reg]['Reg_outputs'].append(rail0_op.rstrip())
                    self.Reg_info[self.num_Reg]['Reg_outputs'].append(rail1_op.rstrip())
#    #                print (self.Reg_info[self.num_Reg]['Reg_inputs'])
                    

 
########        NEW COMBINATIONAL MERGING ALGORITHM #########################

##----------- if gates receive inputs from Reg_NULL outputs, then the input of gates should be replaced by inputs of reg_nULL -------------------               

            for i in range(1,self.num_gates+1):
                for j in range (1, self.num_Reg+1):
                    for x in self.gate_info[i]['gate_inputs']:
                        if x == self.Reg_info[j]['rail0_output'][0]:
                            for n, k in enumerate (self.gate_info[i]['gate_inputs']):
                                if k == x:
                                    self.gate_info[i]['gate_inputs'][n] = self.Reg_info[j]['rail0_input'][0]
                        if x == self.Reg_info[j]['rail1_output'][0]:
                            for n, k in enumerate (self.gate_info[i]['gate_inputs']):
                                if k == x:
                                    self.gate_info[i]['gate_inputs'][n] = self.Reg_info[j]['rail1_input'][0]                    

## If register (i) generating PRIMARY Output receive inputs from gate (j), then gate(j) output will be replaced by register (i) output -------------------
            
            for i in range (1, self.num_RegN+1):
                if (self.RegN_info[i]['rail0_output'][0] in self.outputs) and (self.RegN_info[i]['rail1_output'][0] in self.outputs):
                    for j in range (1,self.num_gates+1):
                        if self.RegN_info[i]['rail0_input'][0] == self.gate_info[j]['gate_outputs'][0]:
                            for x in range (1,self.num_gates+1):
                                for n, y in enumerate (self.gate_info[x]['gate_inputs']):
                                    if y == self.gate_info[j]['gate_outputs'][0]:
                                        self.gate_info[x]['gate_inputs'][n] = self.RegN_info[i]['rail0_output'][0]
                            self.gate_info[j]['gate_outputs'][0]= self.RegN_info[i]['rail0_output'][0] 
                    for j in range (1,self.num_gates+1):
                        if self.RegN_info[i]['rail1_input'][0] == self.gate_info[j]['gate_outputs'][0]:
                            for x in range (1,self.num_gates+1):
                                for n, y in enumerate (self.gate_info[x]['gate_inputs']):
                                    if y == self.gate_info[j]['gate_outputs'][0]:
                                        self.gate_info[x]['gate_inputs'][n] = self.RegN_info[i]['rail1_output'][0]
                                    
                            self.gate_info[j]['gate_outputs'][0]= self.RegN_info[i]['rail1_output'][0] 

## If one gate goes through multiple null registers before producing final outputs----------------
           
            for i in range (1, self.num_Reg+1):
                s1 = []
                checked=[]
                if (self.Reg_info[i]['rail0_output'][0] in self.outputs) and (self.Reg_info[i]['rail1_output'][0] in self.outputs):                 
                        for j in range (1, self.num_Reg+1):
                            if self.Reg_info[i]['Reg_inputs'] == self.Reg_info[j]['Reg_outputs']:
                                s1.append(j)
                        for x in s1:
                            if x not in checked:
                                for k in range (1, self.num_Reg+1):                                
                                    if self.Reg_info[x]['Reg_inputs']== self.Reg_info[k]['Reg_outputs']:
                                        s1.append(k)
                                        checked.append(x)
                                    else:
                                        for v in range (1, self.num_gates+1):
                                            if self.Reg_info[x]['rail0_input'][0]== self.gate_info[v]['gate_outputs'][0]:
                                                self.gate_info[v]['gate_outputs'][0]= self.Reg_info[i]['rail0_output'][0]
                                            if self.Reg_info[x]['rail1_input'][0]== self.gate_info[v]['gate_outputs'][0]:
                                                self.gate_info[v]['gate_outputs'][0]= self.Reg_info[i]['rail1_output'][0]   
                                    
#                                    print (checked)      



     
        ##---------------------- Inverter checking starts----------##
            already_done= []
            for x in range (1, self.num_gates+1):
                count = 0
                not_level=0
    #            bb = str('Nothing')
                for y in self.gate_info[x]['gate_inputs']:  
                    z= int (self.gate_info[x]['level'])
                    mat1= re.search (r'(.*_(?P<rail>[0-9]+)$)',y)
                    mat= re.search (r'((?P<variable>\w+)_)',y)
                    m= mat1.group ('rail')
                    m1= mat.group ('variable')
                    H= m1 +  '_1'
#                    print (H)
                    
                    if m=='0' and y not in already_done and y in self.inputs: 
                        self.num_not += 1
                        count +=1
                        self.not_info[self.num_not] = dict()
                        ## check if primary input is inverted##
                        self.not_info[self.num_not]['Level']= str(1)                
                        
                        self.not_info[self.num_not]['Type']= 'not'
                        self.not_info[self.num_not]['output']= y
                        self.not_info[self.num_not]['input']= H
                        if z<=1:
                            z= z+1
                            self.gate_info[x]['level']= str(z)
                        already_done.append(y)
    #                print (count)
    #                    print (self.not_info[self.num_not]['input'])
                    if m=='0' and y in already_done:
                        if z<=1:
                            z=z+1
                            self.gate_info[x]['level']= str(z)
                            count+=1
                if count>=1:
                    for k in range (1, self.num_gates+1):
                        for i in self.gate_info[k]['gate_inputs']:  
                            if self.gate_info[x]['gate_outputs'][0].rstrip()== i:
                              if int(self.gate_info[k]['level'])<= int (self.gate_info[x]['level']):
                                  self.gate_info[k]['level'] = str(int (self.gate_info[x]['level']) + 1)
# ###########        For correcting all final levels by checking the outputs which go to other gate inputs
            for x in range (1, self.num_gates+1):
                #for gates
                for y in range (1, self.num_gates+1):
                    for i in self.gate_info[y]['gate_inputs']:
                        if self.gate_info[x]['gate_outputs'][0]==i:
                           if int(self.gate_info[y]['level'])<= int (self.gate_info[x]['level']):
                               self.gate_info[y]['level'] = str(int (self.gate_info[x]['level']) + 1) 

#    ##### Combinational logic merging ends ----------------------------------------##################
#             
    @property
    def heading_file(self):
        """Returns the heading for output file"""
        return 'SCL to Synchronous converted Netlist\n'+ '\n'
      
    @property
    def inputs_sync(self):
        """Returns the declarations of the input variables"""
        return 'Inputs:'+ ' '+ ' '.join(variable.strip() for variable in self.inputs) + '\n' 
#
    @property
    def outputs_sync(self):
        """Returns the declarations of the output variable"""
        return 'Outputs:'+ ' ' + ' '.join(variable.strip() for variable in self.outputs) + '\n' 
    
    def gate_struc(self,x):
        """Returns the declarations of the gate variables"""
        return (self.gate_info[x]['type']) +' ' + (self.gate_info[x]['level']) + ' '  + ','.join(variable.strip() for variable in self.gate_info[x]['gate_inputs']) + ' ' + ' '.join(variable.strip() for variable in self.gate_info[x]['gate_outputs']) + '\n' 
       
    def not_struc(self,x):
        """Returns the declarations of the  not gate variables"""
        return (self.not_info[x]['Type']) +' ' + (self.not_info[x]['Level']) + ' '  + (self.not_info[x]['input']) + ' ' + (self.not_info[x]['output']) + '\n' 
    
    def RegD_struc(self,x):
        """Returns the declarations of the gate variables"""
        return  (self.RegD_info[x]['type']) +' ' + (self.RegD_info[x]['level']) + ' '  + ','.join(variable.strip() for variable in self.RegD_info[x]['rail0_init_input'])+ ','+  ','.join(variable.strip() for variable in self.RegD_info[x]['rail1_init_input']) + ' ' + ','.join(variable.strip() for variable in self.RegD_info[x]['rail0_output'])+ ','+ ','.join(variable.strip() for variable in self.RegD_info[x]['rail1_output']) + '\n'              
    @property
    def footer_smt2(self):
        """conversion done"""
        return '\nNetlist conversion done \n'
#
    def generate_SCLtosyn(self):
        """Generate the final smt2 file to the output file"""
        with open(self.outfile, 'w') as smt2_file:
            smt2_file.write(self.heading_file)
##
            smt2_file.write(self.inputs_sync)
            smt2_file.write(self.outputs_sync)
            for x in range (1, self.num_not+1):
                smt2_file.write(self.not_struc(x))
            for x in range (1, self.num_gates+1):
                smt2_file.write(self.gate_struc(x))

            for x in range (1, self.num_RegD+1):
                smt2_file.write(self.RegD_struc(x)) 

            smt2_file.write(self.footer_smt2)